#include "../ti83plus.inc"
#include "../mirage.inc"

#define	m1	AppBackUpScreen

#define	cur			m1+0   ;location of cursor
#define	buf			m1+1   ;96 byte buffer of screen
#define	getvalue		m1+109 ;getcsc previous key value

.org $9D93
.db $BB,$6D,$C9,$01
.db $00,$78,$00,$30,$01,$32,$01,$FE,$01,$FE,$01,$32,$00,$30,$FF
.db $78,$81,$00,$A5,$00,$81,$00,$81,$00,$A5,$00,$81,$00,$FF,$00
Descript:
.db "Crates v1.0",0

Start:
	;save contrast
	ld	a,(cont)
	out	($10),a

	call	disp_menu

Start_Game:
	call	gs_off
	ld	a,(level)
	ld	b,a \ sla a
	add	a,b ;a = (level * 3)
	ld	e,a
	ld	d,0
	ld	hl,levels
	add	hl,de
	ld	a,(hl)
	ld	(cur),a
	inc	hl
	ld	a,(hl)
	ld	b,a
	inc	hl
	ld	a,(hl)
	ld	l,a
	ld	h,0
	ld	de,huffdata
	add	hl,de
	call	dehuff

	call	gs_on
Main_Loop:
	call	getcsc
	cp	skLeft	\ jr z,Left
	cp	skRight	\ jr z,Right
	cp	skUp		\ jr z,Up
	cp	skDown	\ jr z,Down
	cp	skGraph	\ jp z,quit
	cp	skDel		\ jr z,Start_Game
	cp	skAdd		\ jr z,won
	cp	skSub		\ jr z,level_dec
	cp	skTrace	\ jr z,help
	cp	skLParen	\ jr z,cont_down
	cp	skRParen	\ jr z,cont_up
	jr	Main_Loop

Left:
	ld	bc,-8
	jr	Down+3
Right:
	ld	bc,8
	jr	Down+3
Up:
	ld	bc,-1
	jr	Down+3
Down:
	ld	bc,1
	call  move

	;check if won
	ld	hl,buf
	ld	b,84
chk:	ld	a,(hl)
	cp	2 \ jr z,Main_Loop
	inc	hl
	djnz	chk
	;player won
won:
	ld	a,(level)
	cp	9 \ jr nz,won2
	ld	a,$FF
won2:	inc	a
	ld	(level),a
	jr	call_disp

level_dec:
	ld	a,(level)
	or	a \ jr nz,level_dec_
	ld	a,10
level_dec_
	dec	a
	ld	(level),a
call_disp:
	call	disp_menu_num
	jp	Start_game

help:
	call	gs_off
	call	disp_help
	jp	Main_Loop-3

cont_up:
	ld	a,(cont)
	inc	a \ jr nz,$+3
	dec	a
	ld	(cont),a
	out	($10),a
	jp	Main_Loop
cont_down:
	ld	a,(cont)
	dec	a
	cp	$BF \ jr nz,$+3
	inc	a
	ld	(cont),a
	out	($10),a
	jp	Main_Loop

quit:
	call	gs_off
	ld	a,(contrast)
	add	a,$D8
	out	($10),a
	ret

move:
	ld	a,(cur)
	ld	e,a \ ld d,0
	ld	hl,buf
	add	hl,de ;hl = cur location
	ld	d,h
	ld	e,l ;de = hl
	xor	a

	add	hl,bc
	or	(hl) \ ret z ;walking into wall
	and	1 \ jr nz,move_ ;jump if moving to empty space
	add	hl,bc
	ld	a,(hl)
	and	3
	cp	1 \ ret nz
	push	de
	ex	de,hl
	add	hl,bc
	ex	de,hl
	push	bc
	call	move_
	pop	de
	or	a
	sbc	hl,de
	pop	de
move_:
	;de = original location
	;hl = new location
	;destroys bc
	ld	a,(hl)
	and	3 \ ld b,a
	ld	a,(de)
	and	4 \ or b
	ld	c,a
	ld	a,(de)
	and	3 \ ld b,a
	ld	a,(hl)
	and	4 \ or b
	ld	(hl),a
	ld	a,c
	ld	(de),a

	push	hl
	ld	de,buf
	or	a
	sbc	hl,de
	ld	a,l
	ld	(cur),a
	pop	hl
	ret

#include "display.asm"
#include "keys.asm"
#include "dehuff.asm"
#include "huffdata.asm"
#include "start.asm"
#include "data.asm"

.end
END
