;huffman decompression by: Kerey Roper
;modified a bit by: robbie mcelrath
;purpose for modification:
; 1. remove if statements so is easier to read
; 2. took out many routines i didn't use

dehuff:
	ld	de,buf
	ld	a,96
dehuff_:
	push	af
	push	de
	call	dehuffbyte
	pop	de
	ld	(de),a
	inc	de
	pop	af
	dec	a
	jr	nz,dehuff_
	ret

;main part by Kerey Roper
dehuffbyte:			;input: hl = address of byte in stream, b = bits to skip
	push hl		;output: a = char, hl = address for next call, b = bits to skip for next call
	pop ix
	ld hl,hufftree
huffnextbyte2:
	ld c,(ix)		;get byte from stream
	ld a,b
	cp 8			;skip 8 bits = get next byte
	jr z,huffnextbyte
	inc b
huffskipbits:
	sla c			;skip over bits and get first relevant bit
	djnz huffskipbits
	ld b,a		;# bits processed
	ld d,0		;for use in add hl,de below
hufftreeloop:
	ld a,(hl)		;get node from tree
	push af
	ld e,a
	and 127		;if bit 7 = 1 then it is a leaf node that holds the char
	cp e
	jr nz,huffretchar	;so return the char
	pop af
	jr c,huffgoright	;go right if bit is 1
	inc hl		;go left if 0
	jr huffwentleft
huffgoright:
	add a,a
	ld e,a		;node is ptr to right child
	add hl,de		;add offset
huffwentleft:
	inc b			;increment # bits processed for current byte
	ld a,b
	cp 8			;check if current byte is out of bits
	jr z,huffnextbyte	;if yes, get next byte
	sla c			;else it was a pointer - continue with subtree
	jr hufftreeloop
huffretchar:
	pop de		;correct stack level
	push ix
	pop hl		;set up hl for next call
	ret
huffnextbyte:
	inc ix
	ld b,0
	jr huffnextbyte2
